//-- copyright
// Nepenthes is a free and open project management software.
// Copyright (C) 2024 The Nirvati developers
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License version 3.
//
// Nepenthes is a fork of OpenProject. The copyright follows:
//
// Copyright (C) 2012-2024 the OpenProject GmbH
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License version 3.
//
// OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
// Copyright (C) 2006-2013 Jean-Philippe Lang
// Copyright (C) 2010-2013 the ChiliProject Team
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
// See COPYRIGHT and LICENSE files for more details.
//++

.router--work-packages-partitioned-split-view,
.router--work-packages-partitioned-split-view-details,
.router--work-packages-full-view,
.router--work-packages-full-create
  .in_modal &
    #main
      top: 12px

.router--work-packages-partitioned-split-view:not(.router--work-packages-full-create),
.router--work-packages-partitioned-split-view-details:not(.router--work-packages-full-create),
.router--work-packages-partitioned-split-view-new:not(.router--work-packages-full-create)
  @include extended-content--bottom
  @include extended-content--right

  // Since only the split screen on the right should touch the bottom,
  // we need to add it manually to the left to avoid a jump there
  .work-packages-partitioned-page--content-left
    padding-bottom: 10px

// Ensure correct height applied to child elements.
// The dom looks like this:
// flash (generated from rails - if it was generated when rendering the page)
// div[ui-view] (main content we want to adjust the height for)
// div style="clear:both;" (is pushed to overflow - of no relevance)
//
// This makes use of more specific rules overwriting less specific ones.
// Per default, the height is always 100
.openproject-base--ui-view,
.work-packages-page--ui-view
  height: 100%

.work-packages-partitioned-query-space--container
  > .toolbar-container
    margin-top: 5px

  .toolbar--editable-toolbar
    font-size: 24px

  // Match both rows and timeline specifically
  tr.row-hovered,
  div.row-hovered
    // Use important to override the background styles from __hl classes
    // That also have to be important (cf. 30863)
    background: var(--gray-light) !important

// Left part of the split view
// == flex container for (table|timeline)
.work-packages-split-view--tabletimeline-side
  height: 100%
  flex: 2
  display: flex
  flex-direction: column
  // Required for any absolute positioned elements within the viewport
  // (e.g., timeline controls)
  position: relative
  // Required for correctly scrolling the inner containers
  overflow: hidden

// Content of the left side
// == flex container for (table+timeline)
.work-packages-split-view--tabletimeline-content
  flex: 1
  display: flex
  overflow: hidden

// Footer of the left side
.work-packages-split-view--tabletimeline-footer
  // Only add margin to lower/right corner
  // to avoid that the toolbar sticks directly at the screen border
  margin-right: 5px

// TABLE half of the tabletimeline flexbox
.work-packages-tabletimeline--table-side
  // Same flex as timeline
  flex: 1 1
  // Show scrollbars for inner content
  overflow: auto
  @include styled-scroll-bar
  // relative for loading indicator
  position: relative
  // Hint browser that this will inner-scroll
  will-change: transform
  // Hinter browser that the content of the flex is contained except for size
  contain: strict

  &.-timeline-visible
    // Show the horizontal scrollbar _always_ (same as timeline)
    overflow-x: scroll
    // Hide the vertical scrollbar
    overflow-y: hidden

// TIMELINE half of the tabletimeline flexbox
.work-packages-tabletimeline--timeline-side
  border-left: 3px solid #E7E7E7
  flex-basis: 50%
  // Show the horizontal scrollbar _always_ (same as table)
  overflow-x: scroll
  // Show the vertical scrollbar when necessary
  overflow-y: auto
  @include styled-scroll-bar
  // Hidden by default
  display: none
  // Hint browser that this will inner-scroll
  will-change: transform
  // Hinter browser that the content of the flex is contained except for size
  contain: strict

.router--work-packages-base
  #content
    height: 100%

  .work-packages-partitioned-page--content-left
    overflow: hidden

  .icon-button, .sort-header, .action-icon
    cursor: pointer

  #attributes
    .form--field-container
      max-width: 400px
